#include <cassert>
#include <chrono>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <string>
#include <thread>
#include <vector>

#include "WireWorld.hpp"

using namespace std::string_literals;

int main(int argc, char* argv[]) {
	const auto& starttime = std::chrono::system_clock::now();

	std::ifstream wwInFile(argv[1]);

	WireWorld grid{wwInFile};

	//{ auto err = std::system("clear"); }
	//std::cout << grid << '\n';
	for (std::size_t i{0}; i < 10000; ++i) {
		//using namespace std::chrono_literals;
		//std::this_thread::sleep_for(1s);

		grid.simulateStep();
		//{ auto err = std::system("clear"); }
		//std::cout << grid << '\n';
	}

	std::cout
	    << "Execution time:"
	    << std::chrono::duration<double>{std::chrono::system_clock::now() -
	                                     starttime}
	           .count()
	    << "s\n";
	return EXIT_SUCCESS;
}